// file: dtn_set_8.cc
// 

// isip include files
//
#include "dt_node.h"
#include "dt_node_constants.h"

// method: set_states_cc
//
// arguments:
//  int_4 num_states_a: (input) number of states at this node
//  int_4* state_index: (input) state index array
//
// return: a logical_1 indicating status
//
// this method sets the state indices for this node
//
logical_1 Dt_node::set_states_cc(int_4 num_states_a, int_4* state_index_a) {  
  
  // initialize the array of state indices
  //
  num_states_d = num_states_a;
  state_index_d = new int_4[num_states_d];
  
  // set the indices
  //
  for(int_4 i=0;i<num_states_d;i++) {    
    state_index_d[i] = state_index_a[i];
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
