// file: lat_set_4.cc
//

// isip include files
//
#include "lattice.h"
#include "lattice_constants.h"

// method: set_model_set_cc
//
// arguments:
//  char_1* model_set_a: (input) model set used in lattice creation
//
// return: a logical_1 indicating status
//
// this method sets the name of the model set used in lattice creation
//
logical_1 Lattice::set_model_set_cc(char_1* model_set_a) {

  // get the length of the input string
  //
  int_4 str_len = strlen((char*)model_set_a);

  // allocate memory for the model set name
  //
  if (model_set_d != (char_1*)NULL) {
    delete [] model_set_d;
  }
  model_set_d = new char_1[str_len + (int_4)1];
  
  // copy the string
  //
  strcpy((char*)model_set_d, (char*)model_set_a);
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
