// file: lex_node_constants.h
//
// this is the header file for the lexical tree node class constants
//

// make sure definitions are only made once
//
#ifndef __ISIP_LEX_NODE_CONSTANTS
#define __ISIP_LEX_NODE_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

#ifndef __ISIP_LINK_LIST_CONSTANTS
#include <link_list_constants.h>
#endif

// define the class name
//
#define LXN_CLASS_NAME (char_1*)"Lex_node"

// define markers
//
#define LXN_NULL_PHONE (int_4)-3
#define LXN_START_PHONE (int_4)-2
#define LXN_STOP_PHONE (int_4)-1
#define LXN_SP_PHONE (int_4)0

// define default LM score
//
#define LXN_LM_SCORE (float_4)-1.0e10

// define type of lex node --- ngram or word graph nodes
//
#define LXN_NGRAM ISIP_TRUE
#define LXN_WORDGRAPH ISIP_FALSE

// end of file
// 
#endif
