// file: mm_cstr_2.cc
//

// isip include files
//
#include "memory_manager.h"
#include "memory_manager_constants.h"

// method: constructor
//
// arguments:
//  int_4 grow_size : (input) the grow size for all other items
//  int_4 node_grow_size : (input) the grow size for link list nodes
//
// return: none
//
// this is an overloaded constructor
//
Memory_manager::Memory_manager(int_4 grow_size_a, int_4 node_grow_size_a) {

  // set the counts
  //
  node_count_d = (int_4)0;
  trace_count_d = (int_4)0;
  lex_count_d = (int_4)0;
  lat_count_d = (int_4)0;
  lpath_count_d = (int_4)0;
  ngram_count_d = (int_4)0;
  hash_count_d = (int_4)0;
  hist_count_d = (int_4)0;
  instance_count_d = (int_4)0;

  // set the total numbers generated
  //
  num_node_d = (int_4)0;
  num_trace_d = (int_4)0;
  num_lex_d = (int_4)0;
  num_lat_d = (int_4)0;
  num_lpath_d = (int_4)0;
  num_ngram_d = (int_4)0;
  num_hash_d = (int_4)0;
  num_hist_d = (int_4)0;
  num_instance_d = (int_4)0;

  // reset the block sizes
  //
  node_grow_size_d = node_grow_size_a;
  trace_grow_size_d = grow_size_a;
  lex_grow_size_d = grow_size_a;
  lat_grow_size_d = grow_size_a;
  lpath_grow_size_d = grow_size_a;
  ngram_grow_size_d = grow_size_a;
  hash_grow_size_d = grow_size_a;
  hist_grow_size_d = grow_size_a;
  instance_grow_size_d = grow_size_a;
  
  // initialize the lists
  //
  trace_list_d = (Link_node*)NULL;
  node_list_d = (Link_node*)NULL;
  lex_list_d = (Link_node*)NULL;
  lat_list_d = (Link_node*)NULL;
  lpath_list_d = (Link_node*)NULL;
  ngram_list_d = (Link_node*)NULL;
  hash_list_d = (Link_node*)NULL;
  hist_list_d = (Link_node*)NULL;
  instance_list_d = (Link_node*)NULL;

  // exit gracefully
  //
}
