// file: tr_size_0.cc
//

// isip include files
//
#include "trace.h"
#include "trace_constants.h"

// method: size_cc
//
// arguments: none
//
// return: an int_4 with number of bytes used by this object
//
// this method counts the size of the current object in bytes
//
int_4 Trace::size_cc() {

  // set the size variable
  //
  int_4 size = 0;
  
  // add the size of each constituent data
  //
  size += sizeof(Lex_node*);                     // lex_next_d          

  size += sizeof(int_4);                         // level_d
  size += sizeof(int_4);                         // state_index_d
  size += sizeof(int_4);                         // phone_index_d

  size += sizeof(int_4);                         // max_hist_d
  size += sizeof(History*);                      // history_d
  size += history_d->size_cc();
  size += sizeof(Instance*);                     // instance_d
  size += instance_d->size_cc();
  
  size += sizeof(float_4);                       // score_d

  // exit gracefully
  //
  return size;
}
