// file: train_hash_cell.h
//

// make sure definitions are made only once
//
#ifndef __ISIP_TRAIN_HASH_CELL
#define __ISIP_TRAIN_HASH_CELL

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

// Train_Hash_cell: a class that defines a cell of a Hash_table 
//
class Train_Hash_cell {

  //---------------------------------------------------------------------------
  //
  // protected data
  //
  //---------------------------------------------------------------------------
protected:

  //declare a variable for debugging
  //
  int_4 debug_level_d;
  
  // contents of the Hash_cell
  //
  // if the hash is operating in STRING_KEY mode then key_str_d is the
  // hash key, if it is operating in INTEGER_KEY mode then key_vec_d is
  // the hash key
  //
  char_1* key_str_d;                        // the hash key
  int_4* key_vec_d;
  int_4 key_size_d;

  // contents of the Hash_cell
  //
  void_p item_d;                            // the hashed item pointer 
  Train_Hash_cell* next_d;                        // the hash_cell with the
                                            // same index as this one
                                     
  //---------------------------------------------------------------------------
  //
  // public methods
  //
  //---------------------------------------------------------------------------
public:

  // required methods
  //
  char_1* name_cc();
  volatile void error_handler_cc(char_1* mname, char_1* msg);
  logical_1 debug_cc(FILE *fp, char_1* message);
  logical_1 set_debug_cc(int_4 debug_level);       
  int_4 size_cc();

  // destructors/constructors
  //
  ~Train_Hash_cell();                                 // destructor
  Train_Hash_cell();                                  // default
  Train_Hash_cell(void_p item, char_1* key_str);      // overloaded
  Train_Hash_cell(void_p item, int_4* key_vec,
		  int_4 key_size);                  // overloaded
  Train_Hash_cell(Train_Hash_cell& cell);                   // copy

  // set methods
  //
  logical_1 set_key_cc(char_1* key_str);
  logical_1 set_key_cc(int_4* key_vec, int_4 key_size);
  logical_1 set_item_cc(void_p item);
  logical_1 set_next_cc(Train_Hash_cell* cell);
  logical_1 set_cc(char_1* key_str, void_p item);
  logical_1 set_cc(int_4* key_vec, int_4 key_size, void_p item);

  // get methods
  //
  logical_1 get_key_cc(char_1*& key_str);
  logical_1 get_key_cc(int_4*& key_vec, int_4& key_size);
  void_p get_item_cc();
  Train_Hash_cell* get_next_cc();

  // clear the contents of the cell
  //
  logical_1 clear_cc();
  
  //---------------------------------------------------------------------------
  //
  // private methods
  //
  //---------------------------------------------------------------------------
private:

};

// end of file
//
# endif
