// file: tr_lat_cstr_1.cc
//

// isip include files
//
#include "train_lattice.h"
#include "train_lattice_constants.h"

// method: default constructor
//
// arguments: none
//
// return: none
//
// this is the default constructor
//
Train_Lattice::Train_Lattice() {

  // set node statistics
  //
  num_arcs_d = TRAIN_LATTICE_DEFAULT_NUM_ARCS;
  num_nodes_d = TRAIN_LATTICE_DEFAULT_NUM_NODES;

  // set node pointers
  //
  lnode_d = (Train_Hash_table*)NULL;
  start_node_d = (Train_Lattice_node*)NULL;

  // set Train_Lattice generation infrmation
  //
  lang_model_d = (char_1*)NULL;
  utterance_d = (char_1*)NULL;
  model_set_d = (char_1*)NULL;

  // set likelihood scale factors
  //
  lm_scale_d = TRAIN_LATTICE_DEFAULT_SCALE;
  word_penalty_d = TRAIN_LATTICE_DEFAULT_PENALTY;
  
  // exit gracefully
  //
}
