// file: tr_lat_init_0.cc
//

// isip include files
//
#include "train_lattice.h"
#include "train_lattice_constants.h"

// method: init_nodes_cc
//
// arguments:
//  Train_Lattice_node** lnodes: (input) array of Train_Lattice node pointers
//
// return: a logical_1 indicating status
//
// this method creates the necessary number of nodes in the Train_Lattice
// and places them in the hash table
//
logical_1 Train_Lattice::init_nodes_cc(Train_Lattice_node** lnodes_a) {

  //  if memory is not already defined return with error
  //
  if (lnodes_a == (Train_Lattice_node**)NULL) {
    return ISIP_FALSE;
  }

  // memory manager
  //
  Train_Memory_manager* manager = Train_Link_list::get_manager_cc();

  // declare memory for each node and add index
  //
  for (int_4 i = 0; i < num_nodes_d; i++) {
    lnodes_a[i] = manager->new_lat_cc();
    lnodes_a[i]->set_node_index_cc(i);
    set_lat_node_cc(lnodes_a[i]);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
