// file: train_lattice_node_constants.h
//
// this is the header for the path lattice node class
//

// make sure definitions are only made once
//
#ifndef __ISIP_TRAIN_LATTICE_NODE_CONSTANTS
#define __ISIP_TRAIN_LATTICE_NODE_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// forward declaration of classes
//
#ifndef __ISIP_TRAIN_LINK_LIST_CONSTANTS
#include <train_link_list_constants.h>
#endif

// define the class name
//
#define TRAIN_LATTICE_NODE_CLASS_NAME (char_1*)"Train_Lattice_node"

// define some numeric constants
//
#define TRAIN_LATTICE_NODE_DEFAULT_TYPE (int_4)0
#define TRAIN_LATTICE_NODE_DEFAULT_PRON_VAR (int_4)0
#define TRAIN_LATTICE_NODE_DEFAULT_FRAME (int_4)0
#define TRAIN_LATTICE_NODE_DEFAULT_INDEX (int_4)0
#define TRAIN_LATTICE_NODE_DEFAULT_NUM_ARCS_IN (int_4)0
#define TRAIN_LATTICE_NODE_DEFAULT_NUM_ARCS_OUT (int_4)0

// define node types
//
#define TRAIN_LATTICE_NODE_WORD (int_4)0
#define TRAIN_LATTICE_NODE_PHONE (int_4)1
#define TRAIN_LATTICE_NODE_SYLLABLE (int_4)2

// end of file
// 
#endif
