// file: convert_mmf_constants.h
//
 
// make sure this file is only included once
//
#ifndef __ISIP_CONVERT_MMF_CONSTANTS
#define __ISIP_CONVERT_MMF_CONSTANTS
 
// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the help file for this utility
//
#define CMMF_HELP_FILE (char_1*)"$ISIP_PROTO/doc/convert_mmf.help"

// define command line options
//
#define CMMF_INPUT_MODE_OPT (char_1*)"-input_mode"
#define CMMF_OUTPUT_MODE_OPT (char_1*)"-output_mode"
#define CMMF_HELP_OPT (char_1*)"-help"

// define the minimum number of arguments
//
#define CMMF_MIN_NUM_ARGS (int_4)3

// define the possible file modes
//
#define CMMF_ASCII_STR (char_1*)"ascii"
#define CMMF_BINARY_STR (char_1*)"binary"
#define CMMF_ASCII (int_4)0
#define CMMF_BINARY (int_4)1

// define the default input and output mode
//
#define CMMF_DEFAULT_INPUT_MODE CMMF_ASCII
#define CMMF_DEFAULT_OUTPUT_MODE CMMF_ASCII

// define the constant string
//
#define CMMF_STR_FEATURE_SIZE "feature_size"
#define CMMF_STR_NUM_STATES "num_states"

// end of file
//
#endif
