// file: grammar_compiler_constants.h
//
// definitions file for the trace projetion decoder
//

// make sure definitions are made only once
//
#ifndef __ISIP_GRAMMAR_COMPILER_CONSTANTS
#define __ISIP_GRAMMAR_COMPILER_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the help file
//
#define GC_HELP_FILE (char_1*)"$ISIP_PROTO/doc/grammar_compiler.help"

// commandline identifiers
//
#define GC_HELP_OPT "-help"
#define GC_INPUT_OPT "-input"
#define GC_OUTPUT_OPT "-output"
#define GC_PROBABLISTIC_OPT "-probabilistic"

// define some constants
//
#define SENTSTART "!SENT_START"
#define SENTEND "!SENT_END"
#define WRD_NULL "!NULL"
#define GC_NODE_BLOCK_SIZE (int_4)99999
#define GC_DEFAULT_BLOCK_SIZE (int_4)9999
#define GC_GRAM_MAX_SYMBOL_SIZE (int_4)9999
#define GC_COMMON_SYMBOL_LEN (int_4)4

// variable character in the grammar
//
#define ISIP_UTTERANCE "$isip_utterance"
#define VARIABLE_CHAR '$'

// regular expression
//
#define SYMBOLS "(){}[]<>|~"
#define BRACE_START "("
#define BRACE_CLOSE ")"
#define ONE_OR_MORE_REPEAT_START "<"
#define ONE_OR_MORE_REPEAT_CLOSE ">"
#define ZERO_OR_MORE_REPEAT_START "{"
#define ZERO_OR_MORE_REPEAT_CLOSE "}"
#define OPTIONAL_START "["
#define OPTIONAL_CLOSE "]"
#define ALTERNATIVE_SYMBOL "|"
#define PROBABILITY_SYMBOL "~"
#define SPACE " "
#define EMPTY SPACE

// end of file
//
#endif
