// file: lat_to_nbest_constants.h
//
// definitions file for the lattice to nbest list utility
//

// make sure definitions are made only once
//
#ifndef __LAT_TO_NBEST_CONSTANTS
#define __LAT_TO_NBEST_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

#ifndef __ISIP_DECODER_CONSTANTS
#include <decoder_constants.h>
#endif

// define the help file
//
#define LTON_HELP_FILE (char_1*)"$ISIP_PROTO/doc/lat_to_nbest.help"

// block sizes for traces
//
#define LTON_DEFAULT_BLOCK_SIZE (int_4)9999
#define LTON_NODE_BLOCK_SIZE (int_4)99999

// nbest constants
//
#define LTON_OP_NBEST "nbest_paths"
#define LTON_NUM_NBEST DEC_NUM_NBEST

#define LTON_FUNCTION DEC_NBEST_LIST_FUNCTION 

// pruning parameters
//
#define LTON_OP_MAX_PATHS "nbest_max_paths"
#define LTON_OP_NBEST_BEAM "nbest_beam"

// grammar / language model
//
#define LTON_OP_LEXICON_FILE "lexicon_file"
#define LTON_OP_LM_FILE "lm_file"

// default values for the language model
//
#define LTON_OP_NGRAM "ngram_order"
#define LTON_OP_LMSCALE "lm_scale"
#define LTON_OP_WORDPENALTY "word_penalty"
#define LTON_NGRAM_ORDER DEC_NGRAM_ORDER
#define LTON_LM_SCALE DEC_LM_SCALE 
#define LTON_WORD_PENALTY DEC_WORD_PENALTY 

// input / output file lists
//
#define LTON_OP_INPUT_LIST "input_lattice_list"
#define LTON_OP_OUTPUT_LIST "output_nbest_list"

// commandline identifiers
//
#define LTON_PARAMS_OPT "-p"
#define LTON_HELP_OPT "-help"

// file i/o related constants
//
#define LTON_WAIT_TIME 5
#define LTON_WAIT_ITER 20

// end of file
//
#endif
